
package com.example.iccmanager;

import android.os.Bundle;
import android.app.Activity;
import android.device.IccManager;
import android.util.Log;
import android.view.Menu;
import android.widget.EditText;

public class MainActivity extends Activity {
    private EditText mNo;
    private IccManager mIccManager;
    IccReaderThread mIccReader;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        mNo = (EditText) findViewById(R.id.editText1);
        
    }

    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        super.onDestroy();
    }



    @Override
    protected void onPause() {
        // TODO Auto-generated method stub
        super.onPause();
        if(mIccReader != null)
            mIccReader.threadrun = false;
        if(mIccManager != null) {
            mIccManager.IccClose();  
            //mIccManager = null;
        }
    }



    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        super.onResume();
        mIccManager = new IccManager();
        mIccReader = new IccReaderThread("ReaderThread");
        mIccReader.start();
    }



    /*
     * Convert byte[] to hex
     * string.这里我们可以将byte转换成int，然后利用Integer.toHexString(int)来转换成16进制字符串。
     * @param src byte[] data
     * @return hex string
     */
    public String bytesToHexString(byte[] src) {
        StringBuilder stringBuilder = new StringBuilder("");
        if (src == null || src.length <= 0) {
            return null;
        }
        for (int i = 0; i < src.length; i++) {
            int v = src[i] & 0xFF;
            String hv = Integer.toHexString(v);
            if (hv.length() < 2) {
                stringBuilder.append(0);
            }
            stringBuilder.append(hv);
        }
        return stringBuilder.toString();
    }


    private boolean onDataReceivedF(final byte[] content, final String type) {
        Log.i("mIccManager","-------onDataReceivedF---------------");
        runOnUiThread(new Runnable() {
            public void run() {
                if (content != null) {
                    //mNo.setText("");
                    
                    String contenta = bytesToHexString(content);
                   if(contenta != null) {
                       int len = contenta.length();
                       mNo.append(type);
                       mNo.append(contenta);
                       mNo.append("\n");
                   }
                    
                 
                }
                }
            });
        return true;
    }
    
    private class IccReaderThread extends Thread {
        private boolean threadrun = true;

        public IccReaderThread(String name) {
            super(name);

        }

        public void run() {
            
            while (threadrun) {
                Log.i("mIccManager","-------run---------------");
                try {
                    sleep(300);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                boolean ret = mIccManager.IccOpen();
                if (!ret) {
                    continue;
                }

                byte[] retb = mIccManager.IccFound();
                if (retb == null && retb.length <= 0) {
                    continue;
                }
                for (int i = 0; i < 4; i++) {
                    android.util.Log.i("mIccManager", "---------------------------------retb=["
                            + retb[i] + "]");
                }
                // 3.solt one has card?
                if (retb[0] != 1) {
                    continue;
                }
                // 4.select solt one
                int status = mIccManager.IccSelect((char) 1);
                if (status == 1) {
                    return;
                }
                byte[] atr = mIccManager.IccAct((char) 5);
                // 6.print the atr
                if (atr == null && atr.length <= 0) {
                    continue;
                }
                for (int i = 0; i < atr.length && atr.length < 33; i++) {
                    android.util.Log.i("mIccManager", "----------------atr=[" + atr[i] + "]");
                }
                onDataReceivedF(atr, "ATR: ");
                
                byte[] apdu_utf = {
                        0x00, (byte) 0xA4, 0x04, 0x00, 0x0E, 0x31, 0x50, 0x41, 0x59, 0x2E, 0x53,
                        0x59, 0x53, 0x2E, 0x44, 0x44, 0x46, 0x30, 0x31, 0x00
                };
                int apdu_count = apdu_utf.length;
                byte[] retr = mIccManager.IccExapdu(apdu_utf, (char) apdu_count);
                if (retr == null && retr.length <= 0) {
                    continue;
                }
                for (int i = 0; i < retr.length; i++) {
                    android.util.Log.i("mIccManager", "----------------retr=[" + retr[i] + "]");
                }
                onDataReceivedF(retr, "APDU Out: ");
                mIccManager.IccClose();
            }
            
        }
    }
}
