
package com.example.magmanager;

import android.media.AudioManager;
import android.media.ToneGenerator;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.app.Activity;
import android.view.Menu;
import android.widget.EditText;

public class MainActivity extends Activity {
    private EditText mNo;
    private MagReadService mReadService;
    private ToneGenerator tg = null;
    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case MagReadService.MESSAGE_READ_MAG:
                    beep();
                    String number = msg.getData().getString(MagReadService.CARD_NUMBER);
                    String track1 = msg.getData().getString(MagReadService.CARD_TRACK1);
                    String track2 = msg.getData().getString(MagReadService.CARD_TRACK2);
                    String track3 = msg.getData().getString(MagReadService.CARD_TRACK3);
                    String validtime = msg.getData().getString(MagReadService.CARD_VALIDTIME);
                    mNo.setText("");
                    mNo.setText(" track1: " + track1 + "\n track2: " +track2  + "\n track3: " +track3 + "\n number: " +number +"\n validtime: " +validtime);
                break;
            }
        }
    };
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        mNo = (EditText) findViewById(R.id.editText1);
        tg = new ToneGenerator(AudioManager.STREAM_MUSIC, ToneGenerator.MAX_VOLUME);
        mReadService = new MagReadService(this, mHandler);
    }

    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        super.onDestroy();
    }

    @Override
    protected void onPause() {
        // TODO Auto-generated method stub
        super.onPause();
        mReadService.stop();
    }

    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        super.onResume();
        mReadService.start();
    }
 
    private void beep() {
        if (tg != null)
            tg.startTone(ToneGenerator.TONE_CDMA_NETWORK_CALLWAITING);
    }
}
