/*
 * Copyright 2009 Cedric Priscal
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package com.urovo.printer.demo;

import android.app.Activity;
import android.content.Intent;
import android.device.PrinterManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


public class PrinterManagerActivity extends Activity{
    private static final String TAG = "MagActivity";
    private Button mPrinteBtn;
    private Button mPrinte1;
    private Button mPrinte2;
    private EditText printInfo;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mPrinteBtn = (Button) findViewById(R.id.print);
        printInfo = (EditText)findViewById(R.id.printer_info);
        mPrinteBtn.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                String messgae = printInfo.getText().toString();
                if(messgae.length() > 0) {
                     
                    doprintwork(messgae);
                } else {
                    Toast.makeText(PrinterManagerActivity.this, "请输入需打印信息！", Toast.LENGTH_SHORT).show();
                }
            }
        });
        
        mPrinte1 = (Button) findViewById(R.id.button1);
        mPrinte1.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                doPrint(2);
            }
        });
        
        mPrinte2 = (Button) findViewById(R.id.button2);
        mPrinte2.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                String messgae = printInfo.getText().toString();
                if(messgae.length() > 0) {
                    doPrint(1);
                } else {
                    Toast.makeText(PrinterManagerActivity.this, "请输入需打印信息！", Toast.LENGTH_SHORT).show();
                }
            }
        });
        

    }

    @Override
    protected void onDestroy() {
        // TODO Auto-generated method stub
        super.onDestroy();

    }

    @Override
    protected void onPause() {
        super.onPause();
    }
    private boolean hasChineseChar(String text) {
        boolean hasChar = false;
        int length = text.length();
        int byteSize = text.getBytes().length;
        
        hasChar = (length != byteSize);
        
        return hasChar;
    }

    void doprintwork(String msg) {
         Intent intentService = new Intent(this, PrintBillService.class);
         intentService.putExtra("SPRT", msg);
         startService(intentService);
     }
    
    void doPrint(int type) {
        PrinterManager  printer = new PrinterManager();
        printer.prn_open();
        printer.prn_setupPage(384, -1);
        switch (type) {
        case 1:
           String text = printInfo.getText().toString();
           if(hasChineseChar(text)){
               printer.prn_drawBarcode(text, 50, 10, 58, 8, 120, 0);
               
           } else {
               printer.prn_drawBarcode(text, 196, 300, 20, 2, 70, 0);
           
               printer.prn_drawBarcode(text, 196, 300, 20, 2, 70, 1);
           
               printer.prn_drawBarcode(text, 196, 300, 20, 2, 70, 2);
           
               printer.prn_drawBarcode(text, 196, 300, 20, 2, 70, 3);
           }
           
           break;

         case 2:
             BitmapFactory.Options opts = new BitmapFactory.Options();    
             opts.inPreferredConfig = Bitmap.Config.ARGB_8888;
             opts.inDensity = getResources().getDisplayMetrics().densityDpi;
             opts.inTargetDensity = getResources().getDisplayMetrics().densityDpi;
             Bitmap img = BitmapFactory.decodeResource(getResources(), R.drawable.unipay, opts);
             printer.prn_drawBitmap(img, 30, 0);
           break;
         case 3:
              printer.prn_drawLine(264, 50, 48, 50, 4); 
              printer.prn_drawLine(156, 0, 156, 120, 2);
              printer.prn_drawLine(16, 0, 300, 100, 2);
              printer.prn_drawLine(16, 100, 300, 0, 2);
           break;
                 
       }
         printer.prn_printPage(0);
         
       printer.prn_close();
      
      
      
       }

}

